    #include<graphics.h>
    #include<bios.h>
    #include<stdio.h>
    #include<conio.h>
    #include<stdlib.h>
    #include<stdarg.h>
    #include<string.h>
    #include<ctype.h>
    #include<time.h>

    #define XX        getx()
    #define YY        gety()
    #define MAX(x,y)  ((x)>(y))?(x):(y)
    #define MIN(x,y)  ((x)<(y))?(x):(y)

    #define LINES     1
    #define POINTS    4
    #define NUM       4
    #define MAXLENGTH 640
    #define RANGE     (rand()%10+1)

    int color[NUM]={RED,GREEN,BLUE,YELLOW};

    typedef struct figure_structure
    {
        int xpos;
        int ypos;
        int color;
    }
    FIG;

	void graphic_function(void);

    void main(void)
    {
        int gd,gm,gerr,prm_ctr;
        gd=VGA;
        gm=VGAHI;
        registerbgidriver(EGAVGA_driver);
        initgraph(&gd,&gm,"");
        gerr=graphresult();
		graphic_function();
        closegraph();
        return;
    }

	void graphic_function(void)
    {
		int counter1,counter2,counter3,loop,x;

        FIG poly[NUM][POINTS][LINES+1];
        int xmod[NUM][POINTS],ymod[NUM][POINTS];
		srand((unsigned)(clock()));
        for(loop=0;loop<NUM;loop++)
        {
            for(counter1=0;counter1<POINTS;counter1++)
            {
                for(counter2=0;counter2<LINES;counter2++)
                {
                    switch(loop%4)
                    {
                        case 0:
                            poly[loop][counter1][counter2].xpos=0;
                            poly[loop][counter1][counter2].ypos=0;
                            break;
                        case 1:
                            poly[loop][counter1][counter2].xpos=639;
                            poly[loop][counter1][counter2].ypos=0;
                            break;
                        case 2:
                            poly[loop][counter1][counter2].xpos=639;
                            poly[loop][counter1][counter2].ypos=479;
                            break;
                        case 3:
                            poly[loop][counter1][counter2].xpos=0;
                            poly[loop][counter1][counter2].ypos=479;
                            break;
                    }
					poly[loop][counter1][counter2].color=0;
                }
                xmod[loop][counter1]=RANGE;
                ymod[loop][counter1]=RANGE;
            }
        }

        while(!bioskey(1))
        {
            for(loop=0;loop<NUM;loop++)
            {
                for(counter1=0;counter1<POINTS;counter1++)
                {
                    for(counter2=0;counter2<LINES-1;counter2++)
                    {
                        poly[loop][counter1][counter2]=poly[loop][counter1][counter2+1];
                    }
                    poly[loop][counter1][counter2].color=color[loop];
                    poly[loop][counter1][counter2].xpos=MIN(poly[loop][counter1][counter2].xpos+xmod[loop][counter1],639);
                    poly[loop][counter1][counter2].xpos=MAX(poly[loop][counter1][counter2].xpos,0);
                    poly[loop][counter1][counter2].ypos=MIN(poly[loop][counter1][counter2].ypos+ymod[loop][counter1],479);
                    poly[loop][counter1][counter2].ypos=MAX(poly[loop][counter1][counter2].ypos,0);
                }
                for(counter1=0;counter1<POINTS;counter1++)
                {
                    if(!counter1)
                    {
                        while((poly[loop][counter1][LINES-1].xpos>poly[loop][POINTS-1][LINES-1].xpos)&&(poly[loop][counter1][LINES-1].xpos-poly[loop][POINTS-1][LINES-1].xpos>MAXLENGTH)) --poly[loop][counter1][LINES-1].xpos;
                        while((poly[loop][counter1][LINES-1].ypos>poly[loop][POINTS-1][LINES-1].ypos)&&(poly[loop][counter1][LINES-1].ypos-poly[loop][POINTS-1][LINES-1].ypos>MAXLENGTH)) --poly[loop][counter1][LINES-1].ypos;
                    }
                    else
                    {
                        while((poly[loop][counter1][LINES-1].xpos>poly[loop][counter1-1][LINES-1].xpos)&&(poly[loop][counter1][LINES-1].xpos-poly[loop][counter1-1][LINES-1].xpos>MAXLENGTH)) --poly[loop][counter1][LINES-1].xpos;
                        while((poly[loop][counter1][LINES-1].ypos>poly[loop][counter1-1][LINES-1].ypos)&&(poly[loop][counter1][LINES-1].ypos-poly[loop][counter1-1][LINES-1].ypos>MAXLENGTH)) --poly[loop][counter1][LINES-1].ypos;
                    }
                    poly[loop][counter1][LINES-1].xpos=MIN(poly[loop][counter1][LINES-1].xpos,639);
                    poly[loop][counter1][LINES-1].xpos=MAX(poly[loop][counter1][LINES-1].xpos,0);
                    poly[loop][counter1][LINES-1].ypos=MIN(poly[loop][counter1][LINES-1].ypos,479);
                    poly[loop][counter1][LINES-1].ypos=MAX(poly[loop][counter1][LINES-1].ypos,0);
                    if(poly[loop][counter1][LINES-1].xpos==639) xmod[loop][counter1]=0-(RANGE);
                    if(poly[loop][counter1][LINES-1].xpos==0) xmod[loop][counter1]=RANGE;
                    if(poly[loop][counter1][LINES-1].ypos==479) ymod[loop][counter1]=0-(RANGE);
                    if(poly[loop][counter1][LINES-1].ypos==0) ymod[loop][counter1]=RANGE;
                }
                for(counter1=0;counter1<POINTS;counter1++)
                {
                    for(counter2=0;counter2<LINES;counter2++)
                    {
                        if(!counter1)
                        {
							setcolor(poly[loop][counter1][counter2].color);
                            line(poly[loop][counter1][counter2].xpos,poly[loop][counter1][counter2].ypos,poly[loop][POINTS-1][counter2].xpos,poly[loop][POINTS-1][counter2].ypos);
                        }
                        else
                        {
                            line(poly[loop][counter1][counter2].xpos,poly[loop][counter1][counter2].ypos,poly[loop][counter1-1][counter2].xpos,poly[loop][counter1-1][counter2].ypos);
                        }
                    }
                }
            }
        }
        bioskey(0);
        return;
	}


